var removetabs = {
	_isRTL : null,
	isRTL : function() {
		if(removetabs._isRTL == null){
			var chromedir;
			try{
				var pref = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefBranch);
				var locale = pref.getCharPref("general.useragent.locale");
				chromedir = pref.getCharPref("intl.uidirection." + locale);
			}catch(e){}
			removetabs._isRTL = (chromedir == "rtl");
		}
		return (removetabs._isRTL);
	},

	execute : function(action, usecontext) {
		button = document.getElementById("removetabsbutton");
		if(action < 0){
			action = button.getAttribute("__removetabs_action") - 0;
		}else{
			button.setAttribute("__removetabs_action", action);
			var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService);
			var prefBranch = prefSvc.getBranch("extensions.removetabs.");
			prefBranch.setIntPref("default_action", action);
		}
		switch(action){
			case 0: removetabs.removeLeft(usecontext); break;
			case 1: removetabs.removeRight(usecontext); break;
			case 2: removetabs.removeOther(usecontext); break;
			case 3: removetabs.removeAll(usecontext); break;
			default: alert("error. action=" + action);
		}
	},

	removeLeft : function(usecontext) {
		var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
		if(removetabs.isRTL()){
			removetabs.removeAfter(ctab);
		}else{
			removetabs.removeBefore(ctab);
		}
	},
	
	removeRight : function(usecontext) {
		var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
		if(removetabs.isRTL()){
			removetabs.removeBefore(ctab);
		}else{
			removetabs.removeAfter(ctab);
		}
	},
	
	removeBefore : function(ctab) {
		var tabs = removetabs.getTabs();
		var i;
		for(i=tabs.length-1; tabs[i] != ctab; i--){}
		for(i--; i>=0; i--){
			if(!tabs[i].pinned){
				gBrowser.removeTab(tabs[i]);
			}
		}
		removetabs.updateEnabled();
	},
	
	removeAfter : function(ctab) {
		var tabs = removetabs.getTabs();
		for(var i=tabs.length-1; tabs[i] != ctab; i--){
			if(!tabs[i].pinned){
				gBrowser.removeTab(tabs[i]);
			}
		}
		removetabs.updateEnabled();
	},
	
	removeOther : function(usecontext) {
		var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
		gBrowser.removeAllTabsBut(ctab);
		removetabs.updateEnabled();
	},
	
	removeAll : function(usecontext) {
		var ctab = gBrowser.addTab(removetabs.getRemoveAllPage());
		gBrowser.removeAllTabsBut(ctab);
		if(removetabs.getTabs().length > 1) {
			gBrowser.removeTab(ctab);
		}
		removetabs.updateEnabled();
	},
	
	getRemoveAllPage : function() {
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch("extensions.removetabs.");
	
		switch(prefBranch.getIntPref("removeall_type")) {
		case 0:
			return "about:blank";
		case 1:
			return gHomeButton.getHomePage();
		case 2:
			return prefBranch.getCharPref("removeall_url");
		default:
			return "about:blank";
		}
	},
	
	setDisabled : function(id, value) {
		var item = gBrowser.ownerDocument.getElementById(id);
		if(item == null){ return; }
		item.setAttribute("disabled", value);
	},
	
	updateEnabled : function() {
		var tabs = removetabs.getTabs();
		if(removetabs.isRTL()){
			removetabs.updateEnabled_rtl(tabs);
		}else{
			removetabs.updateEnabled_ltr(tabs);
		}
		var removeallDisabled = tabs.length == gBrowser._numPinnedTabs ||
			(tabs.length <= 1 &&
			 (gBrowser.currentURI.spec == "" || gBrowser.currentURI.spec == "about:blank"));
		removetabs.setDisabled("tab-removeallmenu", removeallDisabled);
		removetabs.setDisabled("removeallbutton", removeallDisabled);
		removetabs.setDisabled("removeotherbutton",
			(tabs.length <= 1 || // for Firefox 3.6
			 tabs.length - gBrowser._numPinnedTabs <= 1 || gBrowser.selectedTab.pinned));
	},
	
	updateEnabled_ltr : function(tabs) {
		var cpos = (gBrowser.mContextTab ? gBrowser.mContextTab._tPos : 0);
		var spos = gBrowser.selectedTab._tPos;
		var pinned = gBrowser._numPinnedTabs || 0; // "|| 0" for Firefox 3.6
		removetabs.setDisabled("tab-removeleftmenu",  (cpos <= pinned));
		removetabs.setDisabled("tab-removerightmenu", (cpos < pinned || cpos == tabs.length - 1));
		removetabs.setDisabled("removeleftbutton",    (spos <= pinned));
		removetabs.setDisabled("removerightbutton",   (spos < pinned || spos == tabs.length - 1));
	},
	
	updateEnabled_rtl : function(tabs) {
		var cpos = (gBrowser.mContextTab ? gBrowser.mContextTab._tPos : 0);
		var spos = gBrowser.selectedTab._tPos;
		var pinned = gBrowser._numPinnedTabs || 0; // "|| 0" for Firefox 3.6
		removetabs.setDisabled("tab-removeleftmenu",  (cpos < pinned || cpos == tabs.length - 1));
		removetabs.setDisabled("tab-removerightmenu", (cpos <= pinned));
		removetabs.setDisabled("removeleftbutton",    (spos < pinned || spos == tabs.length - 1));
		removetabs.setDisabled("removerightbutton",   (spos <= pinned));
	},
	
	addMenuItem : function(browser, menuid) {
		if(!browser){ return; }
		var removetabsMenu = browser.ownerDocument.getElementById(menuid).cloneNode(false);
		if(!removetabsMenu){ return; }
		removetabsMenu.id = "tab-" + menuid;
		var menuParent = removetabs.getTabContextMenu(browser);
		var closeOtherTabsEl = document.getElementById("context_closeOtherTabs");
		if(!closeOtherTabsEl){
			menuParent.appendChild(removetabsMenu);
		}else{
			menuParent.insertBefore(removetabsMenu, closeOtherTabsEl);
		}
	},
	
	addMenuItems : function(browser) {
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch("extensions.removetabs.");
	
		if(prefBranch.getBoolPref("add_removeleft_menu")) {
			removetabs.addMenuItem(browser, "removeleftmenu");
		}
		if(prefBranch.getBoolPref("add_removeright_menu")) {
			removetabs.addMenuItem(browser, "removerightmenu");
		}
		if(prefBranch.getBoolPref("add_removeall_menu")) {
			removetabs.addMenuItem(browser, "removeallmenu");
		}
	},
	
	init : function() {
		removetabs.addMenuItems(gBrowser);
	
		var menuParent = removetabs.getTabContextMenu(gBrowser);
		menuParent.addEventListener("popupshowing", removetabs.updateEnabled, false);
		var contentArea = gBrowser.ownerDocument.getElementById("appcontent");
		contentArea.addEventListener("load", removetabs.updateEnabled, true);
		contentArea.addEventListener("select", removetabs.updateEnabled, false);
		contentArea.addEventListener("unload", removetabs.updateEnabled, true);
		
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService);
		var prefBranch = prefSvc.getBranch("extensions.removetabs.");
		var default_action = prefBranch.getIntPref("default_action");
		if(default_action >= 0 && default_action <= 3){
			var button = gBrowser.ownerDocument.getElementById("removetabsbutton")
			if(button){
				button.setAttribute("__removetabs_action", default_action);
			}
		}

		removetabs.updateEnabled();
	},
	
	getTabs : function() {
		// "visibleTabs" was introduced in Firefox 4.0.
		return gBrowser.visibleTabs || gBrowser.tabContainer.childNodes;
	},

	getTabContextMenu : function(browser) {
		// browser.mStrip is deprecated in Firefox 4.0.
		return browser.tabContextMenu || browser.mStrip.firstChild.nextSibling;
	}
};
